import { ClientPlugin } from '@readme/httpsnippet/targets';
import { OASDocument } from 'oas/types';

interface APIOptions {
    api: {
        definition: OASDocument;
        /**
         * The string to identify this SDK as. This is used in the `import sdk from '<identifier>'`
         * sample as well as the the variable name we attach the SDK to.
         *
         * @example `@api/developers`
         */
        identifier?: string;
        /**
         * The URI that is used to download this API definition from `npx api install`.
         *
         * @example `@developers/v2.0#17273l2glm9fq4l5`
         */
        registryURI: string;
    };
    escapeBrackets?: boolean;
    indent?: string | false;
}
declare const plugin: ClientPlugin<APIOptions>;

export = plugin;
